/*
 Shamelessly stolen from linux v0.01, with comments added.
*/

#ifndef _COS_ASM_H_
#define _COS_ASM_H_

// enable and disable interrupts
#define sti() __asm__ ("sti"::)
#define cli() __asm__ ("cli"::)

// no operation
#define nop() __asm__ ("nop"::)

// return from interrupt
#define iret() __asm__ ("iret"::)

// input and output
#define outb(value,port) \
__asm__ ("outb %%al,%%dx"::"a" (value),"d" (port))

#define inb(port) ({ \
unsigned char _v; \
__asm__ volatile ("inb %%dx,%%al":"=a" (_v):"d" (port)); \
_v; \
})

// input and output with delay
#define outb_p(value,port) \
__asm__ ("outb %%al,%%dx\n" \
		"\tjmp 1f\n" \
		"1:\tjmp 1f\n" \
		"1:"::"a" (value),"d" (port))

#define inb_p(port) ({ \
unsigned char _v; \
__asm__ volatile ("inb %%dx,%%al\n" \
	"\tjmp 1f\n" \
	"1:\tjmp 1f\n" \
	"1:":"=a" (_v):"d" (port)); \
_v; \
})

#endif // !_COS_ASM_H_
