
#ifndef _STDTYPES_H_
#define _STDTYPES_H_

// word types, platform-dependent sizes
typedef unsigned char		half_t;
typedef unsigned short		word_t;
typedef unsigned long		dword_t;
typedef unsigned long long	quad_t;

// integer types, independent sizes
typedef signed char			sbyte_t;		// 8-bit, signed
typedef unsigned char		ubyte_t;		// 8-bit, unsigned
typedef signed short		sshort_t;		// 16-bit, signed
typedef unsigned short		ushort_t;		// 16-bit, unsigned
typedef signed long			slong_t;		// 32-bit, signed
typedef unsigned long		ulong_t;		// 32-bit, unsigned
typedef signed long long	slonglong_t;	// 64-bit, signed
typedef unsigned long long	ulonglong_t;	// 64-bit, unsigned

// standard aliases
typedef ubyte_t				byte_t;
typedef sshort_t			short_t;
typedef slong_t				long_t;
typedef slonglong_t			longlong_t;

// integer types, dependent sizes
typedef int					int_t;
typedef unsigned int		unsigned_t;
typedef signed int			signed_t;

// string types
typedef char				char_t;
typedef char*				string_t;
typedef const char*			cstring_t;

// pointer and memory types
typedef void*				pvoid_t;
typedef void*				ptr_t;
typedef const void*			cptr_t;
typedef unsigned long		ptrdiff_t;
typedef unsigned long		size_t;
typedef unsigned long		iptr_t;

// others
typedef int					count_t;	// allow negative counts
typedef char				bool_t;		// allow negative values for bool as well

// files
typedef dword_t fileh;

// boolean values
#define True 1
#define False 0
#define IsTrue(x) (x != 0)
#define IsFalse(x) (x == 0)

#define NULL (0)
#define INT_MAX	2147483647
#define INT_MIN	(-INT_MAX - 1)

#endif // !_STDTYPES_H_
