#include <debugger.h>

volatile struct savedData* progData ;
volatile int fromThread=0;
int progLoaded=0;
extern "C" void displayTss(){
	printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x,esp0=%x,ss0=%x,ldt=%x",THREAD_TSS->eax,THREAD_TSS->ebx,THREAD_TSS->ecx,THREAD_TSS->edx,THREAD_TSS->esi,THREAD_TSS->edi,THREAD_TSS->esp,THREAD_TSS->ebp,THREAD_TSS->eflags,THREAD_TSS->eip,THREAD_TSS->ds,THREAD_TSS->gs,THREAD_TSS->fs,THREAD_TSS->es,THREAD_TSS->cs,THREAD_TSS->ss,THREAD_TSS->esp0,THREAD_TSS->ss0,THREAD_TSS->ldt);
}
void displayProgData(){
	/*
IMP: Take care while changing the esp or ss also , the same rules shall apply
	 */
	dword_t ss,esp;
	if(fromThread){
		if( (gdtGet(THREAD_TSS->cs))->dpl==0x0) {
			ss=THREAD_TSS->ss;
			esp=progData->old_sp- 12;
		}else {
			ss=progData->ss;
			esp=progData->sp;
		}
		printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x",progData->ax,progData->bx,progData->cx,progData->dx,progData->si,progData->di,esp,progData->bp,progData->eflags,progData->eip,progData->ds,progData->gs,progData->fs,progData->es,progData->cs,ss);
	}else 
		printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x",THREAD_TSS->eax,THREAD_TSS->ebx,THREAD_TSS->ecx,THREAD_TSS->edx,THREAD_TSS->esi,THREAD_TSS->edi,THREAD_TSS->esp,THREAD_TSS->ebp,THREAD_TSS->eflags,THREAD_TSS->eip,THREAD_TSS->ds,THREAD_TSS->gs,THREAD_TSS->fs,THREAD_TSS->es,THREAD_TSS->cs,THREAD_TSS->ss);
}
void run(){
	CLEAR_BIT(TF_BIT,THREAD_TSS->eflags);
	if(fromThread) CLEAR_BIT(TF_BIT,progData->eflags);
	switch_to(threadTss.sel<<3);
}
int _i;
char ptrArray[100][100];
mem_t threadCode,threadStack,threadData;
int createWordList(char* s){
	int i;
	char* c;
	c=strtok(s," \t");
	i=0;
	while(c){
		strcpy(ptrArray[i],c);
		c=strtok(NULL," \t");
		i++;
	}
	return i; 
}
void load(int start,int size,int dsSize,int stackSize,int ispriv){
	printk("\n In the load function ");
	int startBlock=start>>9;
	privilege priv=USER;
	int startOffset=start&((1<<9)-1);
	int endBlockNo=(start+size-1)>>9;
	int numBlockReq=endBlockNo-startBlock+1;
	printk("\n Num of blocks reqd is %d",numBlockReq);
	int numPageReq=BLOCK2PAGE(numBlockReq);
	char* c=(char*)pgAlloc_c(numPageReq);
	if(ispriv) {priv=KERNEL ;printk("\n Warning , running code at kernel priv, you are on your own now");}
	printk("\n c= %x",(void*)c);
	printk("\n Num of pages reqd is %d",numPageReq);
	memset(c,0,numPageReq*PAGE_SIZE);
	int i;
	char* cx=c;
	if(stackSize<=0) stackSize=1;
	if(dsSize<=0) dsSize=1;
	//reading code from floppy
	for(i=startBlock;i<=endBlockNo;i++){
		printk("\n Going to read sector %d",i);
		FloppyRead(i);
		memcpy(cx,(char*)DMA_START_ADDR,512);
		cx+=512;
	}
	printk("\n Read the floppy ");
	//freeing the alloced threadCode,threadData,threadStack
	printk("\n The suspects are %d,%d,%d",threadCode.npage,threadStack.npage,threadData.npage);
	//PRINT_BITMAP
	fromThread=0;
	free_mem(&threadCode);
	free_mem(&threadStack);
	free_mem(&threadData);
	printk("\n Freed memory %d",size);
	
	threadCode.npage=((size-1)>>12)+1;
	printk("\n Allocating %d pages for code",threadCode.npage);
	threadCode.page=pgAlloc_c(threadCode.npage);
	printk("\n threadCode.page =%x",(void*)threadCode.page);
	threadCode.sel=installSegment(threadCode.page,PAGE_SIZE*threadCode.npage,CODE,priv);

	threadStack.npage=stackSize;
	printk("\n Allocating %d pages for stack",threadStack.npage);
	threadStack.page=pgAlloc_c(threadStack.npage);
	threadStack.sel=installSegment(threadStack.page,PAGE_SIZE*threadStack.npage,DATA,priv);
	
	threadData.npage=dsSize;
	printk("\n Allocating %d pages for data",threadData.npage);
	threadData.page=pgAlloc_c(dsSize);
	threadData.sel=installSegment(threadData.page,PAGE_SIZE*threadData.npage,DATA,priv);
	
	buildThreadTSS(threadCode,threadData,threadStack);
	
	printk("\n Code/Data/Stack sizes are %d,%d,%d, with selectors %x,%x,%x",threadCode.npage,threadData.npage,threadStack.npage,threadCode.sel,threadData.sel,threadStack.sel);
	printk("\n Size=%d,startOffset=%d,c=%d,threadCode.page=%x,threadData.page=%x,threadStack.page=%x",size,startOffset,(int)c,(int)(threadCode.page),threadData.page,threadStack.page);
	memcpy(threadCode.page,c+startOffset,size);
	pgRelease_c(c,numPageReq);
	printk("\n Executing this \n");
	for(c=(char*)threadCode.page;c<512+(char*)threadCode.page; c++) printk("%x",(byte_t)(*c));
	//PRINT_BITMAP
	progLoaded=1;
}
void step(){
	if(fromThread) SET_BIT(TF_BIT,progData->eflags);
	else SET_BIT(TF_BIT,THREAD_TSS->eflags);
	switch_to(threadTss.sel<<3);
}
void startdebugger(){
	int i=0;
	fromThread=0;
	progLoaded=0;
	InstallHandler(1,DebuggerInterrupt);
	InstallHandler(3,DebuggerInterrupt);
	buildKernelTSS();
	initThreadTSS();
	//the below would be done in the load funx.
	init_prog_seg()
//	char** ptrArray=(char** )pgAlloc();
	char* buf=(char*)pgAlloc();
	//ptrArray[i] is the ptr to the ith word.
	int args[8];//max seven args, 1 to 7
	while(1){
		printk("\n[La Debugger]>> ");
		gets(buf,PAGE_SIZE);
		//printk("\n >>%s<<",buf);
		//while(1);
		int numWords=createWordList(buf);//,ptrArray);	
		//for(i=0;i<numWords;i++) printk("Word %dth is %s ",i,ptrArray[i]);
		//printk("\n NumWords is %d",numWords);
		if(numWords<=0 || numWords>7) {
			printk("\n ***Wrong num of args or bad command \n");
			continue;
		}
		if(!stricmp(ptrArray[0],"load")){
			//parse load args and call load
			//load <startbyte> <size> <dsSize> <stackSize>
			CHECK_ARGS_LEN(5)	
			for(i=1;i<=5;i++){
				printk("\n The string thing is %s",ptrArray[i]);
				args[i]=(int)(strtoi(ptrArray[i],10,0));
			}
			printk("\n The args you entered are %d,%d,%d,%d",args[1],args[2],args[3],args[4]);
			if(args[1]<0||(args[1]+args[2])>MAX_FLOPPY_BYTES||args[2]<=0) ILLEGAL_ARGS
			load(args[1],args[2],args[3],args[4],args[5]);
		}else if(!stricmp(ptrArray[0],"step")){
			check_load()
			step(); //change run to run default , step to trace
			displayProgData();
		}else if(!stricmp(ptrArray[0],"run")){
			check_load()
			run(); //change run to run default , step to trace
			displayProgData();
		}else if(!stricmp(ptrArray[0],"showtss")){
			check_load();
			displayTss();	
		}else if(!stricmp(ptrArray[0],"dump")){
			check_load();
			displayProgData();	
		}else if(!stricmp(ptrArray[0],"exit")){
			printk("\n You kidding me , this is an OS sonny , wanna quit ,press the big red switch !! \n");
			break;
		}else
			printk("\n Bad command entered , valid commands are load ,run,showtss,dump,exit");
	}
//	pgRelease(ptrArray);
	pgRelease(buf);

	while(1);
}

