#include <tss.h>
mem_t ktss;
mem_t threadTss;
void buildKernelTSS(){
	//ktss.page=pgAlloc();
	ktss.page=(ptr_t)KERNEL_TSS_START;
	ktss.npage=1;
	ktss.sel=installSegment(ktss.page,ktss.npage*PAGE_SIZE,TSS,SYSTEM);

	struct tss_struct* KTssPtr= (struct tss_struct*)ktss.page;
	memset((ptr_t)KTssPtr,0,sizeof(struct tss_struct));

	KTssPtr->es=KERNEL_DS&0xffff;
	KTssPtr->ds=KERNEL_DS&0xffff;
	KTssPtr->ss=KERNEL_DS&0xffff;
	KTssPtr->fs=KERNEL_DS&0xffff;
	KTssPtr->gs=KERNEL_DS&0xffff;
	KTssPtr->cs=KERNEL_CS&0xffff;
	KTssPtr->ldt=DUMMY_LDT&0xffff;
	KTssPtr->trace_bitmap=0;
	word_t i=ktss.sel<<3;
	asm ("ltr %0":: "a" (i));
	
}

void initThreadTSS(){
	//threadTss.page=pgAlloc();
	threadTss.page=(ptr_t)THREAD_TSS_START;
	threadTss.npage=1;
	threadTss.sel=installSegment((ptr_t)(threadTss.page),threadTss.npage*PAGE_SIZE,TSS,SYSTEM);
}
void buildThreadTSS(mem_t code,mem_t data,mem_t stack){
	dword_t i;
	long ds;
	struct tss_struct* ThreadTssPtr= (struct tss_struct*)threadTss.page;
	DEBUG_MEM(&code);
	DEBUG_MEM(&data);
	DEBUG_MEM(&stack);
	//cli();
	memset((ptr_t)ThreadTssPtr,0,sizeof(struct tss_struct));
	int dsPriv,csPriv,ssPriv;
	dsPriv=(gdtGet(data.sel))->dpl;
	csPriv=(gdtGet(code.sel))->dpl;
	ssPriv=(gdtGet(stack.sel))->dpl;
	printk("\n Ikde ala");
	ds=(data.sel<<3)&0xffff|dsPriv;
	ThreadTssPtr->esp0=(dword_t)((void*)ThreadTssPtr)+PAGE_SIZE;
	ThreadTssPtr->es=ds;
	ThreadTssPtr->ss0=KERNEL_DS;
	ThreadTssPtr->ds=ds;
	ThreadTssPtr->ss=((stack.sel<<3)&0xffff)|ssPriv;
	ThreadTssPtr->fs=ds;
	ThreadTssPtr->gs=ds;
	ThreadTssPtr->cs=((code.sel<<3)&0xffff)|csPriv;
	ThreadTssPtr->esp=stack.npage*PAGE_SIZE-1;
	(ThreadTssPtr->eflags)=1<<(IF_BIT);
	ThreadTssPtr->ldt=DUMMY_LDT&0xffff;
	//The gen reg's including the eip have all been inited to 0 by memset
	ThreadTssPtr->trace_bitmap=0;
	//sti();
	
	printk("\n These are the cs,ds,ss,esp0,ss0 : %x,%x,%x,%x,%x",ThreadTssPtr->cs,ThreadTssPtr->ds,ThreadTssPtr->ss,ThreadTssPtr->esp0,ThreadTssPtr->ss0);
}
void doDebuggerInt(dword_t dr6){
	//jump back to the kernel
	fromThread=1;
	switch_to(ktss.sel<<3); //this <<3 is real imp
}
